"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var prisma_datamodel_1 = require("prisma-datamodel");
var modelNameNormalizer_1 = require("./modelNameNormalizer");
var model_1 = require("../../../../prisma-datamodel/dist/datamodel/model");
var ModelNameAndDirectiveNormalizer = /** @class */ (function (_super) {
    __extends(ModelNameAndDirectiveNormalizer, _super);
    function ModelNameAndDirectiveNormalizer(baseModel) {
        var _this = _super.call(this) || this;
        _this.baseModel = baseModel;
        _this.baseType = null;
        return _this;
    }
    // https://github.com/prisma/prisma/issues/3725
    ModelNameAndDirectiveNormalizer.prototype.normalize = function (model) {
        _super.prototype.normalize.call(this, model);
    };
    ModelNameAndDirectiveNormalizer.prototype.findBaseByName = function (baseObjs, obj) {
        var _a = __read(baseObjs.filter(function (base) {
            if (base.databaseName) {
                return base.databaseName === obj.name;
            }
            else {
                return base.name === obj.name;
            }
        }), 1), baseCandidate = _a[0];
        return baseCandidate || null;
    };
    ModelNameAndDirectiveNormalizer.prototype.findBaseByRelation = function (baseObjs, obj) {
        if (typeof obj.type === 'string') {
            return null;
        }
        var fieldType = obj.type;
        var _a = __read(baseObjs.filter(function (base) {
            return (typeof base.type !== 'string' &&
                base.type.name === fieldType.name &&
                // Only check the relation name if is it set on base. It might have been omitted.
                (base.relationName === null ||
                    obj.relationName === null ||
                    base.relationName === obj.relationName));
        }), 1), baseCandidate = _a[0];
        return baseCandidate || null;
    };
    ModelNameAndDirectiveNormalizer.prototype.findBaseById = function (baseObjs, obj) {
        var _a = __read(baseObjs.filter(function (baseObj) { return baseObj.isId && obj.isId; }), 1), baseCandidate = _a[0];
        return baseCandidate || null;
    };
    ModelNameAndDirectiveNormalizer.prototype.assignProperties = function (baseObj, obj) {
        if (baseObj.databaseName) {
            obj.name = baseObj.name;
            obj.databaseName = baseObj.databaseName;
        }
    };
    ModelNameAndDirectiveNormalizer.prototype.assignTypeProperties = function (baseObj, obj) {
        if (baseObj === null) {
            return;
        }
        this.assignProperties(baseObj, obj);
    };
    ModelNameAndDirectiveNormalizer.prototype.assignFieldProperties = function (baseObj, obj, parentModel) {
        if (baseObj === null) {
            return;
        }
        this.assignProperties(baseObj, obj);
        obj.isId = obj.isId || baseObj.isId;
        obj.isCreatedAt = obj.isCreatedAt || baseObj.isCreatedAt;
        obj.isUpdatedAt = obj.isUpdatedAt || baseObj.isUpdatedAt;
        obj.defaultValue = obj.defaultValue || baseObj.defaultValue;
        obj.associatedSequence =
            obj.associatedSequence || baseObj.associatedSequence;
        // Overwrite strategy, if database has none, prisma might have some.
        if (obj.idStrategy === model_1.IdStrategy.None) {
            obj.idStrategy = baseObj.idStrategy;
        }
        if (baseObj.associatedSequence) {
            obj.associatedSequence = __assign({}, baseObj.associatedSequence);
        }
        // Override JSON mapped to string.
        if (obj.type === prisma_datamodel_1.TypeIdentifiers.string &&
            baseObj.type === prisma_datamodel_1.TypeIdentifiers.json) {
            obj.type = prisma_datamodel_1.TypeIdentifiers.json;
        }
        if (obj.type === prisma_datamodel_1.TypeIdentifiers.string &&
            typeof baseObj.type !== 'string' &&
            baseObj.type.isEnum) {
            // We found an enum type field shadowed by prisma.
            var baseEnumType_1 = baseObj.type;
            // Attempt to find the enum type
            var candidateEnum = parentModel.types.find(function (x) { return x.isEnum && x.name === baseEnumType_1.name; });
            if (candidateEnum !== undefined) {
                obj.type = candidateEnum;
            }
        }
    };
    ModelNameAndDirectiveNormalizer.prototype.normalizeType = function (type, parentModel) {
        if (this.baseModel === null) {
            this.baseType === null;
        }
        else {
            this.baseType = this.findBaseByName(this.baseModel.types, type);
        }
        this.assignTypeProperties(this.baseType, type);
        _super.prototype.normalizeType.call(this, type, parentModel, this.baseType !== null);
    };
    ModelNameAndDirectiveNormalizer.prototype.normalizeField = function (field, parentType, parentModel) {
        var baseField = null;
        if (this.baseType !== null) {
            baseField = this.findBaseByName(this.baseType.fields, field);
            if (baseField !== null) {
                this.assignName(field, baseField.name);
                this.assignFieldProperties(baseField, field, parentModel);
            }
            else {
                // Fallback to ID.
                baseField = this.findBaseById(this.baseType.fields, field);
                if (baseField !== null) {
                    this.assignFieldProperties(baseField, field, parentModel);
                }
                else {
                    // Fallback to relation.
                    baseField = this.findBaseByRelation(this.baseType.fields, field);
                    if (baseField !== null) {
                        // Hard-override name. Relation names are usually auto-generated.
                        field.name = baseField.name;
                        field.databaseName = baseField.databaseName;
                        if (baseField.relationName === null ||
                            field.relationName === null) {
                            // Remove relation name if it is unset in ref model,
                            // Set relation name if set on ref model but not for us.
                            field.relationName = baseField.relationName;
                        }
                        // If this is a self-referencing field with a back connection on the same type, we copy
                        // the name of the related field as well. Otherwise, we always
                        // end up overwriting or name with the first ocurrence in the reference.
                        if (field.type == parentType &&
                            baseField.relatedField !== null &&
                            field.relatedField !== null) {
                            field.relatedField.name = baseField.relatedField.name;
                            field.relatedField.relationName =
                                baseField.relatedField.relationName;
                        }
                        this.assignFieldProperties(baseField, field, parentModel);
                    }
                }
            }
            if (baseField !== null) {
                this.assignName(field, baseField.name);
                this.assignFieldProperties(baseField, field, parentModel);
            }
        }
        _super.prototype.normalizeField.call(this, field, parentType, parentModel);
    };
    return ModelNameAndDirectiveNormalizer;
}(modelNameNormalizer_1.default));
exports.default = ModelNameAndDirectiveNormalizer;
//# sourceMappingURL=modelNameAndDirectiveNormalizer.js.map